#!/usr/bin/php
<?PHP
/**************************************************
 * C O R E   S E C T I O N   D E V E L O P M E N T
 *-------------------------------------------------
 * File: gen.php --> PHP5 file.
 * Program: auction house restocker thingy
 *------------------------------------------------
 *                 Copyright 2012 Core Section LLC
 * ID: FFXAH100
 *************************************************/
// created by Nick Barmeda
error_reporting(1);
$start = time();
require_once 'db.class.php';

parse_str(implode('&', array_slice($argv, 1)), $_GET);

$ffsite = "http://www.ffxiah.com/item/";
if (!$_GET['ffxi']) {
	$sqlprice = "Y";
} else {
	$sqlprice = "N";
}

$db = new Db;
$datestamp = '1325482385';
$seller = "ffxiAH";

if (!$_GET) {
	echo "=================================================================================\n";
	echo " DarkStar Project - Auction House Generator				v1.00\n";
	echo "=================================================================================\n";
	echo "\n";
	echo "You did not specify any running commands.\n";
	echo "\n\n";
	echo "syntax: php gen.php options\n";
	echo "	baseprice=x	set the base price for the items.\n";
	echo "	amt=x		set the amount of items you wish to add, default is 3\n";
	echo "	ffxi=true	this will take the median price from ffxiah. SLOW.(~5500 seconds)\n";
	echo "	history=1	history lines for price, set to 0 if you do not wish to have\n";
	echo "			history. default 1\n";
	echo "	clearah=1	this will clear the AH.  [Non-Recoverable]\n";
	echo "	duplication=1	this will duplicate the last sold values under ".$seller." name.\n";
	echo "			(used in crons for ffxiah prices)\n";
	echo "\n";
	echo "example: php gen.php baseprice=100 amt=10 history=1 \n";
	echo "example: php gen.php ffxi=true amt=10 history=2\n";
	echo "example: php gen.php clearah=1\n";
	echo "example: php gen.php duplication=1 amt=7\n";
	echo "\n";
	echo "This script was designed for crontabs, however the ffxi mode is not recommended in crontabs.\n";
	echo "This script was designed for *nix, and require a textmode browser for ffxi mode.\n";
	echo "\n\n";
	die;
}


if ($_GET['clearah'] == 1) {
	echo "You have chosen to clear the AH.  This process cannot be recovered.\n";
	echo "Are you sure? [Y/N]: ";
	$rawdate = fopen ("php://stdin","r");
	$rawyn = trim(fgets($rawdate));
	switch ($rawyn) {
		case "Y":
			echo "Clearing AH Table.  The AH will have no items or history.\n\n";
			$db = new Db();
			$db->updateDb("TRUNCATE TABLE auction_house");
			echo "Auction house cleared.\n";
			die;
		break;

		case "y":
			echo "Clearing AH Table.  The AH will have no items or history.\n\n";
			$db = new Db();
			$db->updateDb("TRUNCATE TABLE auction_house");
			echo "Auction house cleared.\n";
			die;
		break;

		case "N":
			echo "Exiting..."; die;
		break;

		case "n":
			echo "Exiting..."; die;
		break;

		default:
			echo "Invalid Entry. Exiting...\n";
			die;
		break;
	}
}

if ($_GET['baseprice']) {
	echo "All Items will have a base price of ".$_GET['baseprice'].". (Randomized)";
	$baseprice = $_GET['baseprice'];
} else {
	if (!$_GET['ffxi']) {
		echo "Base Price not specified.  Default is the SQL Price.\n";
		$baseprice = '1';
	}
}




//check for lynx
if ($_GET['ffxi']) {
echo "You have chosen to pull median numbers from FFXIAH.com.  This process takes a while...\n";
echo "Please do not use this option when set in a crontab that runs hourly, it's alot of traffic.\n";

if (preg_match("/Lynx Version/",shell_exec('lynx --version'))) {
	echo "You have LYNX\n"; $cmd = "lynx --dump ";
	}
elseif (preg_match("/ELinks", shell_exec('elinks --version')) && !$cmd) {
	echo "You have eLinks\n"; $cmd = "elinks --dump ";
}
elseif(preg_match("/Links/", shell_exec('links --version')) && !$cmd) {
	echo "You have links\n"; $cmd = "links --dump ";
}
else { echo "You do not have a text mode browser installed.  Please install Lynx, eLinks or Links and try again.\n\n"; die; }
}

if (!$_GET['history']) { $hist = 1; }
	else { $hist = $_GET['history']; }

if (!$_GET['amt']) { 
	echo "You did not specify an amount, we will use the default of 3.\n";
	$amt = 3;
} else {
	$amt = $_GET['amt'];
	echo "You have specified ".$_GET['amt']." of each item to be added.  Proceeding...\n\n";
}


function insAH($item, $stamp, $prc, $sell, $stk, $amt) {
	$x=1;
	$db = new Db();
	// don't overstock
	$stock = $db->queryDb("SELECT * from auction_house where itemid = '".$item."' AND buyer_name IS NULL AND sale = '0' AND sell_date = '0'");
	$x = count($stock);
	//
	while ($x < $amt) {
		$db->updateDb("INSERT INTO auction_house (`id`, `itemid`, `stack`, `seller`, `seller_name`, `date`, `price`) VALUES('', '".$item."', '".$stk."', '0', '".$sell."', '".$stamp."', '".$prc."')");
		$x++;
	}
}

function insAH_History($item,$stamp, $prc, $sell, $stk, $amt) {
	$x=0;
	$db = new Db();
	// do not add another history line unless it doesn't exist.
	$histexist = $db->queryDb("SELECT itemid from auction_house where itemid = '".$item."' AND sale = '".$prc."' AND sell_date = '".$stamp."';");
	$x = count($histexist);
	while ($x < $amt) {
		$db->updateDb("INSERT INTO auction_house VALUES('', '".$item."', '".$stk."', '0', '".$sell."', '".$stamp."', '".$prc."', '".$sell."', '".$prc."', '".$stamp."');");
		$x++;
	}
}

echo "Generating AH items...\n";
if ($_GET['duplication'] == 1) { // for duplicating FFXIah values
	$dupitems = $db->queryDb("select distinct id,itemid,stack from auction_house where seller_name = '".$seller."' AND buyer_name = '".$seller."' AND date = '".$datestamp."'");
	$duptotal = count($dupitems);
	foreach ($dupitems as $itm) {
		$dnum++;
		$item_name = $db->queryDb("select name from item_basic where itemid = '".$itm['itemid']."'");
		$item_name = trim(ucwords(preg_replace("/_/", " ", $item_name[0]['name'])));
		if ($itm['stack'] == 1) { 
			$stknum = $db->queryDb("SELECT stackSize from item_basic where itemid = '".$itm['itemid']."'");
			$item_name = $item_name." :: Stack: x".$stknum[0]['stackSize'];
		}
		$price_ah = $db->queryDb("select price from auction_house where id = '".$itm['id']."'");
		echo "[".$dnum."/".$duptotal."] -DUPLICATION- Item Name: ".$item_name." 		Price: ".$price_ah[0]['price']."\n";
		insAH($itm['itemid'], $datestamp, $price_ah[0]['price'], $seller, $itm['stack'], $amt);
	
	}
unset($dupitems, $duptotal, $dnum);
} else {
$basicitems = $db->queryDb("SELECT * FROM item_basic where NoSale = '0' AND aH != '0' AND aH != '99'");
$total = count($basicitems);
foreach ($basicitems as $bitm) {
	$itemc++;
	if ($bitm['stackSize'] != 1) {
		if ($sqlprice == 'Y') {
			$prstk[1] = $bitm['BaseSell'];
			if (!$prstk[1] || $prstk[1] <= 0) {
				$prstk[1] = round(mt_rand(1,$baseprice) * $bitm['stackSize']);
			}
			else {
				$prstk[1] = round($bitm['stackSize'] * mt_rand(1,$baseprice));
			}
		} else {
			$link = $ffsite.$bitm['itemid']."?stack=1";
			$prstk =  explode("Median ", shell_exec('lynx --dump '.$link.' | grep Median'));
		}
		// add stack
		if ($prstk[1]) {
			$rn = ucwords(preg_replace("/_/", " ", $bitm['name']));
			echo "[".$itemc."/".$total."] Item Name: ".$rn." Stack: ".$bitm['stackSize']." Price: ".number_format($prstk[1])."\n";
			insAH_History($bitm['itemid'], $datestamp, trim($prstk[1]), $seller, "1", $hist);
			insAH($bitm['itemid'], $datestamp, trim($prstk[1]), $seller, "1", $amt);
			unset($prstk,$rn);
		}
		// add single even if we add stack
		if ($sqlprice == 'Y') {
			$prsng[1] = $bitm['BaseSell'];
			if (!$prsng[1] || $prsng[1] <= 0) {
				$prsng[1] = round(mt_rand(1,$baseprice));
			}
		} else { 
			$lsing = $ffsite.$bitm['itemid'];
			$prsng = explode("Median ", shell_exec('lynx --dump '.$lsing.' | grep Median'));
		}
		if ($prsng[1]) {
			$rn = ucwords(preg_replace("/_/", " ", $bitm['name']));	
			echo "[".$itemc."/".$total."] Item Name: ".$rn." Price: ".number_format($prsng[1])."\n";
			insAH_History($bitm['itemid'], $datestamp, trim($prsng[1]), $seller, "0", $hist);
			insAH($bitm['itemid'], $datestamp, trim($prsng[1]), $seller, "0", $amt);
			unset($prsng,$rn);
		}
	} else { // add items that do not have a stack 
		if ($sqlprice == 'Y') {
			$pri[1] = round(mt_rand(1,$baseprice));
		} else {
			$link = $ffsite.$bitm['itemid'];
			$pri = explode("Median ", shell_exec('lynx --dump '.$link.' | grep Median'));
		}
		if ($pri[1]) {
			$rn = ucwords(preg_replace("/_/", " ", $bitm['name']));
			echo "[".$itemc."/".$total."] Item Name: ".$rn."  Price: ".number_format($pri[1])."\n";
			insAH_History($bitm['itemid'], $datestamp, trim($pri[1]), $seller, "0", $hist);
			insAH($bitm['itemid'], $datestamp, trim($pri[1]), $seller, "0", $amt);
			unset($pri,$rn);
		}
	}
}
}
$end = time();

$total = $end - $start;
echo "Script Execution Time: ".$total." seconds.\n\n";
?>
